/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/08/2017
 --------------------------------------------------------
 */
package com.portofolio.entity;


import org.hibernate.annotations.ForeignKey;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AKHIR_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AWAL_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.DECIMAL;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.VARCHAR;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.TypeDataObjek;
import com.portofolio.entity.vo.RangeId;

import org.hibernate.annotations.Type;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Entity
@Table(name = "Range_M")
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class Range {
	@EmbeddedId
	private RangeId id;

	private static final String cDefFactorRate = DECIMAL + AWAL_KURUNG + "15,2" + AKHIR_KURUNG;
	@Column(name = "FactorRate", columnDefinition = cDefFactorRate)
	private java.math.BigDecimal factorRate;

	private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
	private String kdDepartemen;

	private static final String cDefKdJenisRange = INTEGER;
	@Column(name = "KdJenisRange", columnDefinition = cDefKdJenisRange)
	@NotNull(message = "range.kdjenisrange.notnull")
	private Integer kdJenisRange;

	private static final String cDefKdTypeDataObjek = INTEGER;
	@Column(name = "KdTypeDataObjek", columnDefinition = cDefKdTypeDataObjek)
	private Integer kdTypeDataObjek;

	private static final String cDefNamaRange = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "NamaRange", columnDefinition = cDefNamaRange)
	private String namaRange;

	private static final String cDefNoUrut = INTEGER;
	@Column(name = "NoUrut", columnDefinition = cDefNoUrut)
	@NotNull(message = "range.nourut.notnull")
	private Integer noUrut;

	private static final String cDefOperatorFactorRate = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "OperatorFactorRate", columnDefinition = cDefOperatorFactorRate)
	private String operatorFactorRate;

	private static final String cDefRangeMax = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "RangeMax", columnDefinition = cDefRangeMax)
	// @NotNull(message = "range.rangemax.notnull")
	private String rangeMax;

	private static final String cDefRangeMin = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "RangeMin", columnDefinition = cDefRangeMin)
	@NotNull(message = "range.rangemin.notnull")
	private String rangeMin;

	private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
	@NotNull(message = "range.reportdisplay.notnull")
	private String reportDisplay;

	private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
	private String kodeExternal;

	private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG;
	@Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
	private String namaExternal;

	private static final String cDefStatusEnabled = INTEGER;
	@Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
	@NotNull(message = "range.statusenabled.notnull")
	@Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;

	private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG;
	@Column(name = "NoRec", columnDefinition = cDefNoRec)
	@NotNull(message = "range.norec.notnull")
	private String noRec;

	private static final String cDefVersion = INTEGER;
	@Version
	@Column(name = "version", nullable = false, columnDefinition = cDefVersion)
	@NotNull(message = "range.version.notnull")
	private Integer version;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false), })
	//@ForeignKey(name="none")//
	private Profile profile;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdDepartemen", referencedColumnName = "KdDepartemen", insertable = false, updatable = false), })
	//@ForeignKey(name="none")//
	private Departemen departemen;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
			@JoinColumn(name = "KdJenisRange", referencedColumnName = "KdJenisRange", insertable = false, updatable = false), })
	//@ForeignKey(name="none")//
	private JenisRange jenisRange;

	@ManyToOne(fetch = FetchType.LAZY)
	@JsonIgnore
	@JoinColumns({
			@JoinColumn(name = "KdTypeDataObjek", referencedColumnName = "KdTypeDataObjek", insertable = false, updatable = false), })
	//@ForeignKey(name="none")//
	private TypeDataObjek typeDataObjek;
}
